import itertools

class Studium:
    def __init__(self, liste):
        self.module=liste
    def get_grade(self, vektor):
        summe1, summe2, summe3  = 0, 0, 0
        for modul, vektorvalue in zip(self.module, vektor):
            score1, score2 = modul.get_modulscore()
            print(modul.name, score1, score2, score1/score2)
            if vektorvalue == 1:
                summe1+=score1
                summe2+=score2
            if vektorvalue == 0 and modul.name!="Orientierungsprüfung":
                summe3+=score2
        if summe3 >  24:

            return 100, summe3
        print(summe1, summe2)
        return summe1/summe2, summe3

class Modul:
    def __init__(self, name, liste):
        self.name = name
        self.kurse = liste
    def get_modulscore(self):
        summe1, summe2 = 0, 0
        for kurs in self.kurse:
            #print(kurs.name, kurs.note, kurs.ects)
            summe1+=kurs.note * kurs.ects
            summe2+=kurs.ects

        #print(summe1, summe2)
        #print("blib", int((summe1/summe2)*10)/10, summe2)
        return int((summe1/summe2)*10)/10*summe2, summe2

class Kurs:
    def __init__(self, name, note, ects):
        self.name = name
        self.note = note
        self.ects = ects

studium=Studium([
    Modul("Orientierungsprüfung", [
        Kurs(name="ECL", note=2.0, ects=6),
        Kurs(name="Prog1", note=1.0, ects=6),
    ]),
    Modul("Sprawi", [Kurs(name="Sprawi", note=1.0, ects=4)]),
    Modul("Prog2", [Kurs(name="Prog2", note=1.3, ects=6)]),
    Modul("Formale Grundlagen", [
        Kurs(name="Logik", note=1.0, ects=6),
        Kurs(name="Mathe", note=2.0, ects=6),
    ]),
    Modul("Proseminare", [
        Kurs(name="1", note=2.0, ects=6),
        Kurs(name="2", note=1.3, ects=6),
        Kurs(name="3", note=1.0, ects=6),
        Kurs(name="4", note=1.3, ects=6),
        Kurs(name="5", note=1.0, ects=6),
    ]),

    Modul("Hauptseminar", [Kurs(name="Hauptseminar", note=1.0, ects=8)]),
    Modul("Syntax", [Kurs(name="Syntax", note=1.7, ects=6)]),
    Modul("Semantik", [Kurs(name="Sprawi", note=1.0, ects=6)]),
    Modul("Statistik", [Kurs(name="Sprawi", note=1.0, ects=6)]),
    Modul("Informatiksache", [Kurs(name="Informatiksache", note=2.0, ects=8)]),
    Modul("Abschlusskolloq", [Kurs(name="Abschlusskolloq", note=1.3, ects=2)]),
    Modul("Softwareprojekt", [Kurs(name="Softwareprojekt", note=1.0, ects=6)]),
    Modul("Abschluss", [
        Kurs(name="BA", note=1.3, ects=12),
        Kurs(name="muendliche", note=1.3, ects=7),
    ]),
    ]
)

scorelist = []
for vektor in itertools.product([0, 1], repeat=10):
    score = studium.get_grade([0]+list(vektor)+[1, 1])
    scorelist.append((score[0], score[1], [0]+list(vektor)+[1, 1]))
scorelist=sorted(scorelist)
for score, score2, vektor in scorelist[:10]:
    print(score, score2, vektor)
best_vektor = scorelist[0][2]
punkte = scorelist[0][1]
grade = scorelist[0][0]
print(f"Optimal solution for {punkte} points found with grade {grade}")
for module, value in zip(studium.module, best_vektor):
    #print(key, value)
    if value==0 and module.name!="Orientierungsprüfung":
        print("Pls remove " + module.name )


print(studium.get_grade([0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]))

