#Noten Eintragen:

Notenverteilung={
 "Orientierung": {"ECL": 2.3, "Prog1": 1.0},
 "Sprawi": 1.0,
 "Prog2": 2.0,
 "Formale Grundlagen": {"Logik": 1.7, "Mathematik": 1.0},
 "Proseminare":
	{"1": 1.3,
	"2": 1.0,
	"3": 1.0,
	"4": 1.3,
	"5": 1.0},
 "Hauptseminar": 1.3,
 "Syntax": 1.0,
 "Semantik": 1.3,
 "Statistik": 1.0,
 "Informatiksache": 1.0,
 "Softwareprojekt": 1.0,
 "Abschlusskolloq": 1.3,
 "Abschluss": {"BA": 1.0, "muendliche": 1.3}
}


Punkteverteilung = {
 "Orientierung": {"ECL": 6, "Prog1": 6},
 "Sprawi": 6,
 "Prog2": 6,
 "Formale Grundlagen": {"Logik": 6, "Mathematik": 6},
 "Proseminare": 
	{"1": 6,
	"2": 6,
	"3": 6,
	"4": 6,
	"5": 6},
 "Hauptseminar": 8,
 "Syntax": 6,
 "Semantik": 6,
 "Statistik": 6,
 "Informatiksache": 8,
 "Softwareprojekt": 6,
 "Abschlusskolloq": 2,
 "Abschluss": {"BA": 12, "muendliche": 7}
}

def check_punkteverteilung_wellformed(punkte_dist:dict) -> bool:

    return True



import itertools
def score(vektor, debug=False):
    
    summe = 0 # NOTE x ECTS
    summe2 = 0 # \Sigma NOTEN

    # rauswerfen:
    summe3 = 0 # insgesamte summe der NOTEN aller ausgelassenen VL
    for i, ((key1,value1), (key2, value2)) in enumerate(zip(Notenverteilung.items(), Punkteverteilung.items())):

        # Rauswerfen:
        if vektor[i]==0:
            if key1=="Orientierung":
                continue
            if type(value1) is not dict:
                summe3+=value2
            else:
                summe3+=sum(value2.values())
            continue

        # immer zählen:
        if type(value1) is not dict:
            summe+=value1*value2
            summe2+=value2
        else:
            modulesumme1=0 # NOTE x ECTS
            modulesumme2=0 # ECTS

            for (key3,value3), (key4, value4) in zip(value1.items(), value2.items()):
                # Note x ECTS für submodule
                modulesumme1+=value3*value4
                modulesumme2+=value4

            precise_ratio = (int((modulesumme1/modulesumme2)*10)/10)
            modulesumme_precise = precise_ratio * modulesumme2
            summe+= modulesumme_precise # modulsumme round down
            summe2+=modulesumme2

    if summe3> 24:
        # FAIL
    
        return 100, summe3
    
    return ((summe/summe2)), summe3


input(("Note in Testkombi: ",score([1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1])))
input(("Note in Testkombi: ",score([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0])))

scorelist=[] # note, summe(ausgelassen)

for vektor in itertools.product([0, 1], repeat=11):
    scored=score([0]+list(vektor)+[1])
    scorelist.append((scored[0], scored[1], [0]+list(vektor)+[1])) # orient & BA müssen angerechnet werden

sorted_list=sorted(scorelist)
print(sorted_list[:10])
best_vektor = sorted_list[0][2]
punkte = sorted_list[0][1]
grade = sorted_list[0][0]

print(f"Optimal solution for {punkte} points found with grade {grade}")

for key, value in zip(Punkteverteilung, best_vektor):
    #print(key, value)
    if value==0 and key!="Orientierung":
        print("Pls remove " + key )

#for a, b, c in sorted_list[:10]:
#    print(c, score(c, False))